def K8S_TEMPLATE = """
apiVersion: v1
kind: Pod
spec:
  containers:
  - name: docker
    image: core.harbor.fwc.dc.kubernetes.vm/dockerhub/library/docker:latest
    command:
    - cat
    env:
    - name: DOCKER_HOST
      value: "tcp://dind.default:2375"
    tty: true
"""

pipeline {
    agent any
    environment {
        PLACEHOLDER = "changeme"
    }
    stages {
        stage('Initialise Agent') {
            agent { kubernetes yaml: "${K8S_TEMPLATE}" }
            stages {
                stage('Install OS dependencies') {
                    steps {
                        container('docker') {
                            sh """
                            # Install dependencies
                            apk add git make bash

                            # Sync all submodules
                            git config --global --add safe.directory `pwd`
                            git config --global --add safe.directory `pwd`/.make
                            git submodule update --init --recursive --remote

                            # Test Make integration
                            make make
                            """
                        }
                    }
                }
                stage('OCI: Lint') {
                    steps {
                        container('docker') {
                            sh 'make oci-lint'
                        }
                    }
                }
                stage('OCI: Build') {
                    steps {
                        container('docker') {
                            sh 'make oci-build'
                        }
                    }
                }
                stage('OCI: Scan') {
                    steps {
                        container('docker') {
                            sh 'make oci-scan'
                        }
                    }
                }
                stage('OCI: publish') {
                    steps {
                        container('docker') {
                            sh 'make OCI_SKIP_PUSH=false oci-publish'
                        }
                    }
                }
                stage('OCI: clean') {
                    steps {
                        container('docker') {
                            sh 'make oci-clean'
                        }
                    }
                }
            }
        }
    }
}